#! /usr/bin/env python

#   This is "Jankas gelbes Mondgesicht Spiel"
#   Version 1.1
#
#   Copyright (C) 2000-2009  Claus Brunzema <mail@cbrunzema.de>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

# configure here ...

chars_to_choose_from="AHPCUOLTQYBIRSMNJDEFGKV,.-1234567890"

animation_length=90
animation_speed=100

main_window_geometry="785x570"

#-------------------------------------------------------------------------
from Tkinter import *
from string import *
import random

class Janka:
    def __init__(self, master):
	self.master = master
	self.master.bind("<Escape>", self.quit_app)
	self.bind_game_keys()
	
	self.smiley = PhotoImage(file="smiley.gif")
	self.unsmiley = PhotoImage(file="unsmiley.gif")
	self.imagestore=[]
	for i in range(3):
	    self.imagestore.append(PhotoImage(file="wink%d.gif" % i).copy())

	frame=Frame(self.master, bg="white")

	self.endbutton=Button(frame, text='Ende',
			      command=self.start_animation,
			      bg="white",
			      relief="flat")
	self.endbutton.pack(side=BOTTOM, fill=X)

	self.playarea = Canvas(frame, bg="white")
	self.playarea.pack(side=TOP, fill=BOTH, expand=1)
	self.playarea.bind("<Configure>", self.update)
	self.text=self.playarea.create_text(0, 0,
					    text=" ",
					    font=("Helvetica", 260, "bold"))
	frame.pack(expand=1, fill=BOTH)
	self.image=0
	self.new_char()

    def bind_game_keys(self):
	self.master.bind("<Key>", self.process_key)
	
    def unbind_game_keys(self):
	self.master.unbind("<Key>")

    def quit_app(self, event=None):
	self.master.quit()
	
    def new_char(self):
	self.char=random.choice(chars_to_choose_from)
	self.playarea.itemconfigure(self.text, text=self.char)

    def show_smiley(self):
	self.unbind_game_keys()
	self.image = self.playarea.create_image(self.center_x,
						self.center_y,
						image=self.smiley)
	self.new_char()
	self.master.after(3000, self.delete_image)
	
    def show_unsmiley(self):
	self.unbind_game_keys()
	self.image = self.playarea.create_image(self.center_x,
						self.center_y,
						image=self.unsmiley)
	self.master.after(3000, self.delete_image)
	
    def delete_image(self):
	self.playarea.delete(self.image)
	self.image=0
	self.bind_game_keys()
	
    def update(self, event):
	self.center_x=event.width/2
	self.center_y=event.height/2
	for item in self.playarea.find_all():
	    self.playarea.coords(item, self.center_x, self.center_y)
	
    def process_key(self, event):
	if upper(event.char)==self.char:
	    self.show_smiley()
	else:
	    self.show_unsmiley()
	    
    def start_animation(self):
	self.unbind_game_keys()
	self.endbutton.configure(state=DISABLED)
	self.anim_count = animation_length
	self.anim_current = 0
	self.anim_images = []
	self.anim_direction = 1
	for i in range(3):
	    self.anim_images.append(
		self.playarea.create_image(
		    self.center_x,
		    self.center_y,
		    image=self.imagestore[i]))
	self.animate()

    def animate(self):
	self.anim_count=self.anim_count - 1
	if self.anim_count == 0:
	    self.quit_app()
	self.anim_current = self.anim_current + self.anim_direction
	if (self.anim_current<0 or self.anim_current>=len(self.anim_images)):
	    self.anim_direction = self.anim_direction * -1
	    self.anim_current = self.anim_current+(2*self.anim_direction)
	self.playarea.lift(self.anim_images[self.anim_current])
    	self.master.after(animation_speed, self.animate)

root=Tk()
root.geometry(main_window_geometry)
root.title("Jankas gelbes Mondgesicht Spiel")
janka=Janka(root)
root.mainloop()
